<?php
/**
 * This file is part of
 * pragmaMx - Web Content Management System.
 * Copyright by pragmaMx Developer Team - http://www.pragmamx.org
 *
 * pragmaMx is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * $Revision: 6 $
 * $Author: PragmaMx $
 * $Date: 2015-07-08 09:07:06 +0200 (Mi, 08. Jul 2015) $
 */

defined('mxMainFileLoaded') or die('access denied');

/* --------- Konfiguration fr den Block ----------------------------------- */

/* Anzahl der Spalten */
$showcolumns = 3;

/* minimale Breite -abgestimmt auf das Theme in px 
  bei reponsiven designs wichtig
*/
$minwidth=150;

/* Anzahl der angezeigten Artikel
 * - eine beliebige Zahl, oder
 * - die globale Variable $GLOBALS['storyhome']
 */
$storynum = $GLOBALS['storyhome'];

/* Die ersten Teile des Artikeltextes anzeigen,
 * - 0 fr nein, oder
 * - eine beliebige Zahl, die die Menge der angezeigten Zeichen definiert
 * HTML-Tags, ausser <br /> werden entfernt und nicht mitgerechnet
 */
$textlen = 150;

/* Bilder im Text anzeigen, wenn $textlen angeschaltet ist
 * false = nein
 * true = ja
 */
$showpics = true;

/* Buttonleiste anzeigen
 * false = nein
 * true = ja */
$showbuttons = true;

/* Kommentarbutton anzeigen in Buttonleiste
 * Einstellungen:
 * 0 = Immer anzeigen
 * 1 = Nur anzeigen, wenn Kommentare vorhanden
 */
$showcombutton = 0;

/* Verffentlichungsdatum anzeigen
 * false = nein
 * true = ja */
$showdate = true;

/* Kategorie zusammen mit der Artikelberschrift anzeigen
 * false = nein
 * true = ja */
$showcattitle = false;

/* Links zu Suche etc. anzeigen
 * false = nein
 * true = ja */
$showextendedlinks = false;

/* Links oberhalb, unterhalb oder an beiden Stellen anzeigen
 * 0 = nur unterhalb
 * 1 = nur oberhalb
 * 2 = ober- und unterhalb
 */
$positionextendedlinks = 0;

/* Bild fr ne Artikel anzeigen
 * false = nein
 * true = ja */
$shownewpic = true;

/* --------- Ende der Konfiguration ----------------------------------------- */

extract($block['settings'], EXTR_OVERWRITE);

global $prefix;

/* der passende Modulname */
$module_name = basename(dirname(__DIR__));

if (!mxModuleAllowed($module_name)) {
    /* Block darf nicht gecached werden und weg... */
    $mxblockcache = false;
    return;
}

/* Block kann gecached werden? */
$mxblockcache = true;

$qry = "SELECT s.sid, cat.catid, aid, s.title, time, DATE_ADD(time, INTERVAL 2 DAY) AS expire, now() AS jetzt, hometext, bodytext, comments, s.counter, topic, informant, notes, acomm, cat.title AS title1
        FROM ${prefix}_stories AS s LEFT JOIN ${prefix}_stories_cat AS cat ON s.catid = cat.catid
        WHERE (ihome='0' OR s.catid='0') AND time <= now() " . pmx_multilang_query('alanguage', 'AND') . "
        ORDER BY s.time DESC, s.sid DESC
        LIMIT " . intval($storynum);

$result = sql_query($qry);
if (!$result) {
    return;
}

$count = 1;
$out = '';
$out2 = '';
$width = floor(99 / $showcolumns)-1;
while ($story = sql_fetch_assoc($result)) {
    $totalcount = strlen(strip_tags($story['hometext'])) + strlen(strip_tags($story['bodytext']));
	
	$tres=sql_query("Select topicimage from ${prefix}_topics WHERE topicid='".$story['catid']."'");
	list($timage)=sql_fetch_row($tres);
	$image=($timage)?mxCreateImage("images/topic/".$tres):"";
	
    $introtext = '';
    if ($textlen) {
        // array zurcksetzen
        $replaces = array();
        $prependtags = array();
        $textlentemp = $textlen;

        if ($showpics) {
            // Alle Tags ausser <br /> & <img> entfernen
            $introtext = trim(strip_tags($story['hometext'], '<br><img>'));
            // <br /> am Textbeginn entfernen
            $introtext = preg_replace('#^(?:<br\s*/*>\s*)*#is', '', $introtext);
            // alle img & br tags suchen und zwischenspeichern
            preg_match_all('#<(br|img)[^>]*>#si', $introtext, $prependtags);
        } else {
            // Alle Tags ausser <br /> entfernen
            $introtext = trim(strip_tags($story['hometext'], '<br>'));
            // <br /> am Textbeginn entfernen
            $introtext = preg_replace('#^(?:<br\s*/*>\s*)*#is', '', $introtext);
            // alle br tags suchen und zwischenspeichern
            preg_match_all('#<br[^>]*>#si', $introtext, $prependtags);
        }

        foreach($prependtags[0] as $i => $img) {
            // einen alternativen String zum Ersetzen erstellen
            $alternate = md5($img);
            // die gewnschte Textlnge um die Textlnge des alternativen String erweitern
            $textlentemp = $textlen + strlen($alternate);
            // den gefundenen Tag in das array stellen
            $replaces[$alternate] = $img;
            // den gefundenen Tag aus dem Text entfernen und dafr den alternativen String einsetzen
            $introtext = trim(str_replace($img, $alternate, $introtext));
        }
        // Text auf die gewnschte Lnge krzen
        $introtext = mxCutString($introtext, $textlentemp, "&nbsp;...", " ");
        // wenn Tags gefunden wurden, die alternativen Textteile wieder
        // durch die im Array zwischengespeicherten Tags ersetzen
        if (count($replaces)) {
            $introtext = str_replace(array_keys($replaces), array_values($replaces), $introtext);
        }

        if ($introtext) {
            $introtext = '<div class="postcontent">' . $introtext . '</div>';
        }
    }
    // das formatierte Datum
    $datetime = '';
    if ($showdate) {
        $datetime = '' . mx_strftime(_SHORTDATESTRING, mxSqlDate2UnixTime($story['time'])) . '';
    }
    // die Buttons
    $buttons = array();
    if ($showbuttons) {
        $buttons[] = '<a href="modules.php?name=' . $module_name . '&amp;file=print&amp;sid=' . $story['sid'] . '" rel="nofollow" target="_blank">' . mxCreateImage('images/menu/print.gif', _BMXPRINTER, array('title' => _BMXPRINTER)) . '</a>';
        if (mxModuleAllowed('Recommend_Us')) {
            $buttons[] = '<a href="modules.php?name=' . $module_name . '&amp;file=friend&amp;sid=' . $story['sid'] . '" rel="nofollow">' . mxCreateImage('images/menu/friend.gif', _BMXFRIEND, array('title' => _BMXFRIEND)) . '</a>';
        }
        $buttons[] = '<a href="modules.php?name=' . $module_name . '&amp;file=article&amp;sid=' . $story['sid'] . '">' . mxCreateImage('images/menu/bytesmore.gif', _BMXBYTESMORE . ' ' . $totalcount, array('title' => _BMXBYTESMORE . ': ' . $totalcount)) . '</a>';
        if ($GLOBALS['articlecomm'] && ($showcombutton == 0 || ($showcombutton == 1 && $story['comments'] > 0))) {
            $buttons[] = '<a href="modules.php?name=' . $module_name . '&amp;file=article&amp;sid=' . $story['sid'] . '#comments">' . mxCreateImage('images/menu/comments2.gif', _COMMENTS, array('title' => _COMMENTS . ' (' . $story['comments'] . ')')) . '</a>';
        }
        $buttons[] = mxCreateUserprofileLink($story['informant'], mxCreateImage('images/menu/informant.gif', _UNICKNAME . ': ' . $story['informant'], array('title' => _UNICKNAME . ': ' . $story['informant'])));
        $buttons[] = mxCreateImage('images/menu/counter.gif', $story['counter'] . ' ' . _READS, array('title' => $story['counter'] . ' ' . _READS),0,TRUE);
    }
    $colspan = count($buttons) + 1;
    // $buttons = '<table cellspacing="1" cellpadding="1" align="right"><tr><td>'.implode('</td><td>', $button).'</td></tr></table>';
    $buttons = '' . implode(' ', $buttons) . '';
    // der Titel des Artikels
    $story['title'] = '<a href="modules.php?name=' . $module_name . '&amp;file=article&amp;sid=' . $story['sid'] . '">' . $story['title'] . '</a>';
    // den Kategoriename mit anzeigen
    if ($showcattitle && $story['catid'] && $story['title1']) {
        $story['title'] = $story['title'] . '<br /><span class="smaller">[<a href="modules.php?name=' . $module_name . '&amp;file=categories&amp;catid=' . $story['catid'] . '">' . $story['title1'] . '</a>]</span>';
    }
    if ($shownewpic && $story['jetzt'] < $story['expire']) {
        $story['title'] = mxCreateImage('images/menu/new.gif', '', 0, 'align="bottom"') . '&nbsp;' . $story['title'];
    }
    
    $out .= '
    <li class="layout-cell" style="width:' . $width . '%;display:inline-block;vertical-align:top;padding:0;margin:0;border:none;min-width:'.$minwidth.'px;">';
	$out .= '<div class="post" style="padding:10px;">';
    if ($datetime || $buttons) {
        $out .= '
            <div class="tiny">
                ' . $datetime . '
				<span style="float:right">'.
				$buttons . '</span>
            </div>
            ';
    }
    $out .= '
            <h4>' . $story['title'] . '</h4>' . $introtext . '
    </div></li>
    ';

 
}
// falls nicht alle Tabellenspalten am Ende gefllt sind, eine zus. anfgen
if ($count && $out) {
    //$out .= '<td colspan="' . ($showcolumns - $count) . '">&nbsp;</td></tr>';
}
// die Links zu anderen Modulen
if ($showextendedlinks) {
    if (mxModuleAllowed('Stories_Archive')) {
        $links[] = '<a href="modules.php?name=Stories_Archive">' . _STORIEARCHIVE . '</a>';
    }
    if (mxModuleAllowed('Submit_News')) {
        $links[] = '<a href="modules.php?name=Submit_News">' . _SUBMITNEWS . '</a>';
    }
    if (mxModuleAllowed('Search')) {
        $links[] = '<a href="modules.php?name=Search&amp;m=' . $module_name . '">' . _NEWS_SEARCH . '</a>';
    }
    if (isset($links)) {
        $out2 = '<div class="content align-center">';
        $out2 .= '[&nbsp;' . implode('&nbsp;|&nbsp;', $links) . '&nbsp;]';
        $out2 .= '</div>';
        switch ($positionextendedlinks) {
            case 2:
                $out = $out2 . $out . $out2;
                break;
            case 1:
                $out = $out2 . $out;
                break;
            case 0:
            default:
                $out .= $out2;
                break;
        }
    }
}
// content-tabelle, nur wenn berhaupt was zum anzeigen da ist...
if ($out) {
    $content = '<div class="postcontent"><ul class="" style="margin: 0 ;padding:0;">' . $out . '</ul></div>';
}


?>